/* Copyright (c) 2003 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor priorita.c */

#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>

#include "strukturyw.h"
#include "struktury.h"
#include "lib.h"
#include "libw.h"
#include "priorita.h"
#include "windows.h"

type_priorita poradnik[MAXWIN];
unsigned int pocet_oken = 0;
#ifdef PSANIPROFI
int show_stdscr_only = 0;

int get_priorita_show_stdscr()
{
    return show_stdscr_only;
}

void priorita_show_stdscr()
{
    unsigned int i;
    show_stdscr_only = !show_stdscr_only;
    if (!show_stdscr_only) {
        /* nechapu, ale musi to tu byt, jinak to na cernobilem
         * terminalu blbne */
        tiskni_dle_priority();
        for (i = 0; i < pocet_oken; i++) {
            redrawwin2(poradnik[i].win);
        }
    }
}
#endif

int pridej_do_priority_p(unsigned char priorita, WINDOW * pad_ptr,
                         int pad_row, int pad_column, int row_min,
                         int col_min, int row_max, int col_max,
                         WINDOW * wmove, int move_x, int move_y)
{
    int i;
    pocet_oken++;
    if (pocet_oken > MAXWIN) {
        pocet_oken--;
        if (global_get(g_warning) == g_w_ano)
            fprintf(stderr, "CHYBA: Prilis mnoho otevrenych oken!");
        return 1;
    }

    if (priorita != 0) {        /* dame jej navrch */
        poradnik[pocet_oken - 1].win = pad_ptr;
        poradnik[pocet_oken - 1].typ = 1;
        poradnik[pocet_oken - 1].priorita = (priorita > MAXPRI) ?
            MAXPRI : priorita;
        poradnik[pocet_oken - 1].pad_row = pad_row;
        poradnik[pocet_oken - 1].pad_column = pad_column;
        poradnik[pocet_oken - 1].row_min = row_min;
        poradnik[pocet_oken - 1].col_min = col_min;
        poradnik[pocet_oken - 1].row_max = row_max;
        poradnik[pocet_oken - 1].col_max = col_max;
        poradnik[pocet_oken - 1].wmove = wmove;
        poradnik[pocet_oken - 1].move_x = move_x;
        poradnik[pocet_oken - 1].move_y = move_y;
    } else {
        for (i = pocet_oken; i > 0; i--) {
            poradnik[i] = poradnik[i - 1];
        }
        poradnik[0].win = pad_ptr;
        poradnik[0].typ = 1;
        poradnik[0].priorita = 0;
        poradnik[0].pad_row = pad_row;
        poradnik[0].pad_column = pad_column;
        poradnik[0].row_min = row_min;
        poradnik[0].col_min = col_min;
        poradnik[0].row_max = row_max;
        poradnik[0].col_max = col_max;
        poradnik[0].wmove = wmove;
        poradnik[0].move_x = move_x;
        poradnik[0].move_y = move_y;
    }
    return 0;
}

int pridej_do_priority_w(unsigned char priorita, WINDOW * win,
                         WINDOW * wmove, int move_x, int move_y)
{
    int i;
    pocet_oken++;
    if (pocet_oken > MAXWIN) {
        pocet_oken--;
        if (global_get(g_warning) == g_w_ano)
            fprintf(stderr, "CHYBA: Prilis mnoho otevrenych oken! (2)");
        return 1;
    }

    if (priorita != 0) {        /* dame jej navrch */
        poradnik[pocet_oken - 1].win = win;
        poradnik[pocet_oken - 1].typ = 0;
        poradnik[pocet_oken - 1].priorita = (priorita > MAXPRI) ?
            MAXPRI : priorita;
        poradnik[pocet_oken - 1].wmove = wmove;
        poradnik[pocet_oken - 1].move_x = move_x;
        poradnik[pocet_oken - 1].move_y = move_y;
    } else {
        for (i = pocet_oken; i > 0; i--) {
            poradnik[i] = poradnik[i - 1];
        }
        poradnik[0].win = win;
        poradnik[0].typ = 0;
        poradnik[0].priorita = 0;
        poradnik[0].wmove = wmove;
        poradnik[0].move_x = move_x;
        poradnik[0].move_y = move_y;
    }
    return 0;
}

int odeber_z_priority(WINDOW * win)
{
    int i;
    for (i = 0; i < pocet_oken; i++) {
        if (poradnik[i].win == win) {
            for (; i < pocet_oken; i++)
                poradnik[i] = poradnik[i + 1];
            pocet_oken--;
            return 0;
        }
    }
    if (global_get(g_warning) == g_w_ano)
        fprintf(stderr, "odeber_z_priority: Okno nenalezeno.\n");
    return 1;
}

void tiskni_dle_priority(void)
{
    int i, pr;
    char pom[50];

/*    if ((RLINES != LINES) || (RCOLS != COLS)) {
	    fprintf(stderr,"Pozor, zmenila se velikost okna!\n");
    }  */

    touchwin2(stdscr);          /* aby si to myslelo ze se neco zmenilo */
    wnoutrefresh2(stdscr);      /* wnoutr. + doupdate = wrefresh */
    /* nejdrive tiskneme s prioritou 0, pak s prioritou 1 atd. */
#ifdef PSANIPROFI
    if (!show_stdscr_only)
#endif
        for (pr = 0; pr <= MAXPRI; pr++)
            for (i = 0; i < pocet_oken; i++) {
                if (poradnik[i].priorita != pr)
                    continue;
                touchwin2(poradnik[i].win);
                if (!poradnik[i].typ) { /* win */
                    if (wnoutrefresh2(poradnik[i].win))
                        if (global_get(g_warning) == g_w_ano) {
                            sprintf(pom,
                                    "wnoutrefresh2(poradnik[%3u].win)", i);
                            perror(pom);
                        }
                } else {        /* pad */
                    if (pnoutrefresh2(poradnik[i].win, poradnik[i].pad_row,
                                      poradnik[i].pad_column,
                                      poradnik[i].row_min,
                                      poradnik[i].col_min,
                                      poradnik[i].row_max,
                                      poradnik[i].col_max) == ERR) {
                        if (global_get(g_warning) == g_w_ano) {
                            perror("pnoutrefresh2(..)");
                            fprintf(stderr,
                                    "\t\t\t%p [%i] %i %i %i %i %i %i\n",
                                    poradnik[i].win, i,
                                    poradnik[i].pad_row,
                                    poradnik[i].pad_column,
                                    poradnik[i].row_min,
                                    poradnik[i].col_min,
                                    poradnik[i].row_max,
                                    poradnik[i].col_max);
                        }
                    }
                }
            }
#ifdef PSANIPROFI
    if (!show_stdscr_only)
#endif
        if (pocet_oken > 0) {
            wmove2(poradnik[pocet_oken - 1].wmove,
                   poradnik[pocet_oken - 1].move_x,
                   poradnik[pocet_oken - 1].move_y);
            wnoutrefresh2((poradnik[pocet_oken - 1].wmove));
        }
    doupdate2();
}
